Upsert an OAuth2 client scopes restriction

Note: This endpoint is in preview and is subject to change. If you have any feedback, contact Datadog support.

POST https://api.ap1.datadoghq.com/api/v2/oauth2/clients/{client_uuid}/scopes_restrictionhttps://api.ap2.datadoghq.com/api/v2/oauth2/clients/{client_uuid}/scopes_restrictionhttps://api.datadoghq.eu/api/v2/oauth2/clients/{client_uuid}/scopes_restrictionhttps://api.ddog-gov.com/api/v2/oauth2/clients/{client_uuid}/scopes_restrictionhttps://api.us2.ddog-gov.com/api/v2/oauth2/clients/{client_uuid}/scopes_restrictionhttps://api.uk1.datadoghq.com/api/v2/oauth2/clients/{client_uuid}/scopes_restrictionhttps://api.datadoghq.com/api/v2/oauth2/clients/{client_uuid}/scopes_restrictionhttps://api.us3.datadoghq.com/api/v2/oauth2/clients/{client_uuid}/scopes_restrictionhttps://api.us5.datadoghq.com/api/v2/oauth2/clients/{client_uuid}/scopes_restriction

Información general

Create or update the scopes restriction configured for the OAuth2 client. This endpoint requires the org_authorized_apps_write permission.

Argumentos

Parámetros de ruta

Nombre

Tipo

Descripción

client_uuid [required]

string

UUID of the OAuth2 client.

Solicitud

Body Data (required)

Expand All

Campo

Tipo

Descripción

data [required]

object

Data object of an upsert OAuth2 scopes restriction request.

attributes

object

Attributes of an upsert OAuth2 scopes restriction request.

oidc_scopes

[string]

OIDC scopes the client is allowed to request.

permission_scopes

[string]

Datadog permission scopes the client is allowed to request. Each value must be a valid permission name.

type [required]

enum

JSON:API resource type for an upsert OAuth2 client scopes restriction request. Allowed enum values: upsert_scopes_restriction

default: upsert_scopes_restriction

{
  "data": {
    "attributes": {
      "oidc_scopes": [
        "openid",
        "email"
      ],
      "permission_scopes": [
        "dashboards_read",
        "metrics_read"
      ]
    },
    "type": "upsert_scopes_restriction"
  }
}

Respuesta

OK

Response payload describing the scopes restriction of an OAuth2 client.

Expand All

Campo

Tipo

Descripción

data [required]

object

Data object of an OAuth2 client scopes restriction response.

attributes [required]

object

Attributes of an OAuth2 client scopes restriction.

required_permission_scopes [required]

[string]

Permission scopes automatically required for this client (for example, mobile-app permission scopes). Returns null when no scopes are required.

scopes_restriction [required]

object

Allowlist of OIDC and permission scopes enforced for the OAuth2 client.

oidc_scopes [required]

[string]

OIDC scopes the client is restricted to.

permission_scopes [required]

[string]

Datadog permission scopes the client is restricted to.

id [required]

uuid

UUID of the OAuth2 client this restriction applies to.

type [required]

enum

JSON:API resource type for an OAuth2 client scopes restriction. Allowed enum values: scopes_restriction

default: scopes_restriction

{
  "data": {
    "attributes": {
      "required_permission_scopes": [
        "mobile_app_access"
      ],
      "scopes_restriction": {
        "oidc_scopes": [
          "openid",
          "email"
        ],
        "permission_scopes": [
          "dashboards_read",
          "metrics_read"
        ]
      }
    },
    "id": "fafa8e1c-36a5-11f0-a83d-da7ad0900001",
    "type": "scopes_restriction"
  }
}

Bad Request

API error response.

Expand All

Campo

Tipo

Descripción

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Not Found

API error response.

Expand All

Campo

Tipo

Descripción

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Too many requests

API error response.

Expand All

Campo

Tipo

Descripción

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Ejemplo de código

                  ## default
# 

# Path parameters
export client_uuid="fafa8e1c-36a5-11f0-a83d-da7ad0900001"
# Curl command
curl -X POST "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.uk1.datadoghq.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/oauth2/clients/${client_uuid}/scopes_restriction" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -H "DD-API-KEY: ${DD_API_KEY}" \ -H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \ -d @- << EOF { "data": { "attributes": { "oidc_scopes": [ "openid", "email" ], "permission_scopes": [ "dashboards_read", "metrics_read" ] }, "type": "upsert_scopes_restriction" } } EOF
"""
Upsert an OAuth2 client scopes restriction returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.o_auth2_client_public_api import OAuth2ClientPublicApi
from datadog_api_client.v2.model.o_auth_oidc_scope import OAuthOidcScope
from datadog_api_client.v2.model.upsert_o_auth_scopes_restriction_data import UpsertOAuthScopesRestrictionData
from datadog_api_client.v2.model.upsert_o_auth_scopes_restriction_data_attributes import (
    UpsertOAuthScopesRestrictionDataAttributes,
)
from datadog_api_client.v2.model.upsert_o_auth_scopes_restriction_request import UpsertOAuthScopesRestrictionRequest
from datadog_api_client.v2.model.upsert_o_auth_scopes_restriction_type import UpsertOAuthScopesRestrictionType
from uuid import UUID

body = UpsertOAuthScopesRestrictionRequest(
    data=UpsertOAuthScopesRestrictionData(
        attributes=UpsertOAuthScopesRestrictionDataAttributes(
            oidc_scopes=[
                OAuthOidcScope.OPENID,
                OAuthOidcScope.EMAIL,
            ],
            permission_scopes=[
                "dashboards_read",
                "metrics_read",
            ],
        ),
        type=UpsertOAuthScopesRestrictionType.UPSERT_SCOPES_RESTRICTION,
    ),
)

configuration = Configuration()
configuration.unstable_operations["upsert_scopes_restriction"] = True
with ApiClient(configuration) as api_client:
    api_instance = OAuth2ClientPublicApi(api_client)
    response = api_instance.upsert_scopes_restriction(
        client_uuid=UUID("fafa8e1c-36a5-11f0-a83d-da7ad0900001"), body=body
    )

    print(response)

Instructions

First install the library and its dependencies and then save the example to example.py and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
# Upsert an OAuth2 client scopes restriction returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.upsert_scopes_restriction".to_sym] = true
end
api_instance = DatadogAPIClient::V2::OAuth2ClientPublicAPI.new

body = DatadogAPIClient::V2::UpsertOAuthScopesRestrictionRequest.new({
  data: DatadogAPIClient::V2::UpsertOAuthScopesRestrictionData.new({
    attributes: DatadogAPIClient::V2::UpsertOAuthScopesRestrictionDataAttributes.new({
      oidc_scopes: [
        DatadogAPIClient::V2::OAuthOidcScope::OPENID,
        DatadogAPIClient::V2::OAuthOidcScope::EMAIL,
      ],
      permission_scopes: [
        "dashboards_read",
        "metrics_read",
      ],
    }),
    type: DatadogAPIClient::V2::UpsertOAuthScopesRestrictionType::UPSERT_SCOPES_RESTRICTION,
  }),
})
p api_instance.upsert_scopes_restriction("fafa8e1c-36a5-11f0-a83d-da7ad0900001", body)

Instructions

First install the library and its dependencies and then save the example to example.rb and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
// Upsert an OAuth2 client scopes restriction returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
	"github.com/google/uuid"
)

func main() {
	body := datadogV2.UpsertOAuthScopesRestrictionRequest{
		Data: datadogV2.UpsertOAuthScopesRestrictionData{
			Attributes: &datadogV2.UpsertOAuthScopesRestrictionDataAttributes{
				OidcScopes: []datadogV2.OAuthOidcScope{
					datadogV2.OAUTHOIDCSCOPE_OPENID,
					datadogV2.OAUTHOIDCSCOPE_EMAIL,
				},
				PermissionScopes: []string{
					"dashboards_read",
					"metrics_read",
				},
			},
			Type: datadogV2.UPSERTOAUTHSCOPESRESTRICTIONTYPE_UPSERT_SCOPES_RESTRICTION,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.UpsertScopesRestriction", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewOAuth2ClientPublicApi(apiClient)
	resp, r, err := api.UpsertScopesRestriction(ctx, uuid.MustParse("fafa8e1c-36a5-11f0-a83d-da7ad0900001"), body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `OAuth2ClientPublicApi.UpsertScopesRestriction`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `OAuth2ClientPublicApi.UpsertScopesRestriction`:\n%s\n", responseContent)
}

Instructions

First install the library and its dependencies and then save the example to main.go and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
// Upsert an OAuth2 client scopes restriction returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.OAuth2ClientPublicApi;
import com.datadog.api.client.v2.model.OAuthOidcScope;
import com.datadog.api.client.v2.model.OAuthScopesRestrictionResponse;
import com.datadog.api.client.v2.model.UpsertOAuthScopesRestrictionData;
import com.datadog.api.client.v2.model.UpsertOAuthScopesRestrictionDataAttributes;
import com.datadog.api.client.v2.model.UpsertOAuthScopesRestrictionRequest;
import com.datadog.api.client.v2.model.UpsertOAuthScopesRestrictionType;
import java.util.Arrays;
import java.util.UUID;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.upsertScopesRestriction", true);
    OAuth2ClientPublicApi apiInstance = new OAuth2ClientPublicApi(defaultClient);

    UpsertOAuthScopesRestrictionRequest body =
        new UpsertOAuthScopesRestrictionRequest()
            .data(
                new UpsertOAuthScopesRestrictionData()
                    .attributes(
                        new UpsertOAuthScopesRestrictionDataAttributes()
                            .oidcScopes(Arrays.asList(OAuthOidcScope.OPENID, OAuthOidcScope.EMAIL))
                            .permissionScopes(Arrays.asList("dashboards_read", "metrics_read")))
                    .type(UpsertOAuthScopesRestrictionType.UPSERT_SCOPES_RESTRICTION));

    try {
      OAuthScopesRestrictionResponse result =
          apiInstance.upsertScopesRestriction(
              UUID.fromString("fafa8e1c-36a5-11f0-a83d-da7ad0900001"), body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling OAuth2ClientPublicApi#upsertScopesRestriction");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}

Instructions

First install the library and its dependencies and then save the example to Example.java and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
// Upsert an OAuth2 client scopes restriction returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_o_auth2_client_public::OAuth2ClientPublicAPI;
use datadog_api_client::datadogV2::model::OAuthOidcScope;
use datadog_api_client::datadogV2::model::UpsertOAuthScopesRestrictionData;
use datadog_api_client::datadogV2::model::UpsertOAuthScopesRestrictionDataAttributes;
use datadog_api_client::datadogV2::model::UpsertOAuthScopesRestrictionRequest;
use datadog_api_client::datadogV2::model::UpsertOAuthScopesRestrictionType;
use uuid::Uuid;

#[tokio::main]
async fn main() {
    let body = UpsertOAuthScopesRestrictionRequest::new(
        UpsertOAuthScopesRestrictionData::new(
            UpsertOAuthScopesRestrictionType::UPSERT_SCOPES_RESTRICTION,
        )
        .attributes(
            UpsertOAuthScopesRestrictionDataAttributes::new()
                .oidc_scopes(vec![OAuthOidcScope::OPENID, OAuthOidcScope::EMAIL])
                .permission_scopes(vec![
                    "dashboards_read".to_string(),
                    "metrics_read".to_string(),
                ]),
        ),
    );
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.UpsertScopesRestriction", true);
    let api = OAuth2ClientPublicAPI::with_config(configuration);
    let resp = api
        .upsert_scopes_restriction(
            Uuid::parse_str("fafa8e1c-36a5-11f0-a83d-da7ad0900001").expect("invalid UUID"),
            body,
        )
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}

Instructions

First install the library and its dependencies and then save the example to src/main.rs and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
/**
 * Upsert an OAuth2 client scopes restriction returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.upsertScopesRestriction"] = true;
const apiInstance = new v2.OAuth2ClientPublicApi(configuration);

const params: v2.OAuth2ClientPublicApiUpsertScopesRestrictionRequest = {
  body: {
    data: {
      attributes: {
        oidcScopes: ["openid", "email"],
        permissionScopes: ["dashboards_read", "metrics_read"],
      },
      type: "upsert_scopes_restriction",
    },
  },
  clientUuid: "fafa8e1c-36a5-11f0-a83d-da7ad0900001",
};

apiInstance
  .upsertScopesRestriction(params)
  .then((data: v2.OAuthScopesRestrictionResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));

Instructions

First install the library and its dependencies and then save the example to example.ts and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"